{
Example for MysqlRowSeek / MysqlRowTell, uses mysql
}

program RowSeekTell;

uses MySQL;

var 
  MHandle:PMySQL;
  MRes : PMySQLRes;
  Row, Dummy : MySQLRow;
  NumFields : LongInt;
  NumRows : Cardinal;
  i, j : Integer;
  OffSt : MySQLRowOffset;

begin
  MHandle := MySQLInit(MHandle);
  { You may need to change the username "proger" to some other name...}
	if MySQLRealConnect (MHandle, 'localhost', 'proger', '', 'test', 0, nil, 0) = nil then
	  WriteLn (' Error: MySQLRealConnect returned nil ')
	else
	  begin
	    Write ('Create Database ''test_MySQLunit''..');
	    if not MySQLCreateDb (MHandle, 'test_MySQLunit') then
	      begin
	        MySQLClose (MHandle);
	        WriteLn ('failed!!! (Maybe extists or you don''t have the permission)');
	        Halt (1)
	      end;
	    WriteLn ('done.');
	    Write ('Select Db to ''test_MySQLunit''..');
	    if not MySQLSelectDb (MHandle, 'test_MySQLunit') then
	      begin
	        MySQLClose (MHandle);
	        WriteLn ('failed!!!');
	        Halt (1)
	      end;
	    WriteLn ('done.');
	    Write ('Create Table ''MySQLtest''..');
	    if not MySQLQuery (MHandle, 
	      'CREATE TABLE MySQLtest (nr INT, firstname VARCHAR (100), lastname VARCHAR (100))') then
	      begin
	        WriteLn ('failed!!!');
	        if not MySQLDropDb (MHandle, 'test_MySQLunit') then
	        WriteLn ('Please Clean up mynually');
	        MySQLClose (MHandle);
	        Halt (1)
	      end;
	    WriteLn ('done.');
	    Write ('Populate the table..');
	    if not (MySQLQuery (MHandle,
	      'INSERT INTO MySQLtest values (1, ''Anne'', ''Clark'')') And
	      MySQLQuery (MHandle,
	      'INSERT INTO MySQLtest values (2, ''Robert'', ''Smith'')') And
	      MySQLQuery (MHandle, 
	      'INSERT INTO MySQLtest values (3, ''Paul'', ''Newman'')') And
	      MySQLQuery (MHandle,
	      'INSERT INTO MySQLtest values (4, ''Jane'', ''Fonda'')') And
	      MySQLQuery (MHandle,
	      'INSERT INTO MySQLtest values (5, ''Karl'', ''Marx'')') And
	      MySQLQuery (MHandle, 
	      'INSERT INTO MySQLtest values (6, ''Bob'', ''Marley'')') ) then
	      begin
	        WriteLn ('failed!!!');
	        if not MySQLDropDb (MHandle, 'test_MySQLunit') then
	        WriteLn ('Please Clean up mynually');
	        MySQLClose (MHandle);
	        Halt (1)
	      end;
	    WriteLn ('done.');
	    if not MySQLQuery (MHandle, 'SELECT * FROM MySQLtest') then
	      WriteLn ('MySQLQuery returned False')
	    else
	      begin
	        MRes := MySQLStoreResult (MHandle);
	        if MRes = nil then
	          WriteLn ('MySQLStoreResult returned nil')
  	      else
  	        begin
  	          NumFields := MySQLNumFields (MRes);
  	          NumRows := MySQLNumRows (MRes);
  	          OffSt := nil;
  	          if NumRows = 0 then
  	            WriteLn ('no entries')
  	          else
  	            for i := 0 to NumRows - 1 do
  	              begin
  	                if i = 2 then OffSt := MySQLRowTell (MRes);
  	                Row := MySQLFetchRow (MRes);
  	                for j := 0 to NumFields - 1 do
  	                  Write (CString2String (Row^[j]), ' ');
  	                WriteLn
  	              end;
  	          if OffSt = nil then
  	            WriteLn ('not doing MySQLRowSeek -- please insert more Rows...')
  	          else
  	            begin
  	              Dummy :=  MySQLRowSeek (MRes, OffSt);
  	              Row := MySQLFetchRow (MRes);
  	              Write ('after MySQLRowSeek: ');
  	              for j := 0 to NumFields - 1 do
  	              Write (CString2String (Row^[j]), ' ');
  	              WriteLn
  	            end;
  	          {Free the Mem and Close MySQL }
  	          MySQLFreeResult (MRes);
  	        end
	  	  end;
      Write ('Clean up..');
      if not MySQLDropDb (MHandle, 'test_MySQLunit') then
        WriteLn ('Can''t Drop Database! Please clean up manually')
      else
        WriteLn ('done.');
      MySQLClose (MHandle)
    end
end.
