{
Executes a Query, uses MySQL
}

program simplequery;

uses MySQL;

var 
  MHandle:PMySQL;
  MRes : PMySQLRes;
  Row : MySQLRow;
  NumFields : LongInt;
  NumRows : Cardinal;
  i, j : Integer;

begin
  MHandle := MySQLInit (MHandle);
  if MySQLRealConnect (MHandle, 'localhost', '', '', '', 0, nil, 0) =nil then
    WriteLn  (' Error: MySQLRealConnect returned nil ')
  else
    begin
      Write ('Create Database ''test_MySQLunit''..');
      { Try to create a database }
      if not MySQLCreateDb (MHandle, 'test_MySQLunit') then
        begin
          { Close the connection to the database }
          MySQLClose (MHandle);
          WriteLn ('failed!!!  (Maybe extists or you don''t have the permission)');
          Halt (1)
        end;
      WriteLn ('done.');
      Write ('Select Db to ''test_MySQLunit''..');
      { Select this newly created database  (similar to "USE") }
      if not MySQLSelectDb (MHandle, 'test_MySQLunit') then
        begin
          MySQLClose (MHandle);
          WriteLn ('failed!!!');
          Halt (1)
        end
    end;
  WriteLn ('done.');
  Write ('Create Table ''MySQLtest''..');
  { Create a table MySQLtest in test_MySQLunit }
  if not MySQLQuery (MHandle, 
    'CREATE TABLE MySQLtest (nr INT, firstname VARCHAR (100), lastname VARCHAR (100))') then
    begin
      WriteLn ('failed!!!');
      if not MySQLDropDb (MHandle, 'test_MySQLunit') then
        WriteLn ('Please Clean up mynually');
      MySQLClose (MHandle);
      Halt (1)
    end;
  WriteLn ('done.');
  { Insert some Data in our table }
  Write ('Populate the table..');
  if not  (MySQLQuery (MHandle,
    'INSERT INTO MySQLtest values (1, ''Anne'', ''Clark'')') And
    MySQLQuery (MHandle,
    'INSERT INTO MySQLtest values (2, ''Robert'', ''Smith'')') And
    MySQLQuery (MHandle, 
    'INSERT INTO MySQLtest values (3, ''Paul'', ''Newman'')') And
    MySQLQuery (MHandle, 
    'INSERT INTO MySQLtest values (4, ''Jane'', ''Fonda'')') And
    MySQLQuery (MHandle, 
    'INSERT INTO MySQLtest values (5, ''Karl'', ''Marx'')') And
    MySQLQuery (MHandle, 
    'INSERT INTO MySQLtest values (6, ''Bob'', ''Marley'')') ) then
    begin
      WriteLn ('failed!!!');
      { Try to drop the database  (cleans up tables automatically) }
      if not MySQLDropDb (MHandle, 'test_MySQLunit') then
        WriteLn ('Please Clean up manually');
      MySQLClose (MHandle);
      Halt (1)
    end;
  WriteLn ('done.');
  { Select all Rows from our table }
  if MySQLQuery (MHandle, 'SELECT * FROM MySQLtest') then
    begin
      { store the results }
      MRes := MySQLStoreResult (MHandle);
      if MRes = nil then
        WriteLn  ('MySQLStoreResult returned nil')
      else
        begin
          { retrive the number of Fields for our query 
            (should be 3 for "nr", "firstname", "lastname") }
          NumFields := MySQLNumFields (MRes);
          { ... and the number of Rows  (must be 6 for our example) }
          NumRows := MySQLNumRows (MRes);
          { print them out }
          WriteLn  ('Number of Rows= ',NumRows,' Number of Fields= ',NumFields);
          if NumRows = 0 then
            WriteLn  ('no entries')
          else
            begin
              { for all Rows... }
              for i := 0 to NumRows - 1 do
                begin
                  { Fetch a Row }
                  Row := MySQLFetchRow (MRes);
                  { print our internal number for it }
                  Write  (i, ') ');
                  { and print each field of our Row }
                  for j := 0 to NumFields - 1 do
                    Write  (CSTRING2String (Row^[j]), ' ');
                  WriteLn
                end;
              {Free the Mem and Close MySQL }
              MySQLFreeResult (MRes)
            end
        end
    end
  else
    WriteLn  ('MySQLQuery returned False.');
  Write ('Clean up..');
  { Drop the Database }
  if not MySQLDropDb (MHandle, 'test_MySQLunit') then
    WriteLn ('Can''t Drop Database! Please clean up manually')
  else
    WriteLn ('done.');
  { And clean the connection }
  MySQLClose (MHandle)
end.
